#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <omp.h>

int main(int argc, char* argv[])
{
	long long num_steps = atoi(argv[1]);
	int np = atoi(argv[2]);

	double x, pi, sum=0.0;
	long long i;
	double step = 1./(double)num_steps;

	time_t start, finish;
	clock_t start2, finish2;

	start2 = clock();
	time(&start);
	
  omp_set_dynamic(0);      // 0-  openmp      
  omp_set_num_threads(np); //   
	 
#pragma omp parallel for private(x) reduction(+:sum)
	for (i=0; i<num_steps; i++)
	{
		x = (i + .5)*step;
		sum = sum + 4.0/(1.+ x*x);
	}
	
	pi = sum*step;
	time(&finish);
	
	finish2 = clock();
	
	double duration = difftime(finish, start);
	double duration2 = double(finish2 - start2) / CLOCKS_PER_SEC;
	
	printf("The value of PI is %15.12f\n", pi);
	printf("The time to calculate PI was %2.2f seconds (%d, %d)\n", duration, start, finish);
	printf("The time to calculate PI was %2.2f seconds (%d, %d)\n", duration2, start2, finish2);

  
	return 0;
}
